﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Diagnostics;
using System.Reflection;
using System.Text.RegularExpressions;

namespace Medic.Data
{
    /// <summary>
    /// Changes the default error message
    /// </summary>
    public class RequiredAttribute : System.ComponentModel.DataAnnotations.RequiredAttribute
    {
        public RequiredAttribute(

        )
        {
            this.
            ErrorMessage = "Wypełnić pole {0}!";
        }
    } public class MaxStringLengthAttribute : MaxLengthAttribute
    {
        public MaxStringLengthAttribute(int l
        ) : base(l) { }
        public override bool
            IsValid(object? value) => base.IsValid(value?.
                ToString()
                );
    }
    public class RequiredNAAttribute
    : RequiredAttribute
    {
        public
            const char
            NA = '.'
            ;
        public
            static readonly string NAString = RequiredNAAttribute.NA.ToString();

        public RequiredNAAttribute
         ()
        {
            this.ErrorMessage = "Pole {0} nie wypełnione powinno zawierać kropkę.";
        }
    }
    public class ZipCodeAttribute
        : RangeAttribute
    {
        public ZipCodeAttribute() : base(
             0X0, 0x1869F

        )
        {
            this.ErrorMessage = "Pole {0} musi zawierać 5\u00A0cyfr arabskich!";
        }
    }
    public enum
 MedicalTitle
    {
        [
       Display(
           Name = ""
       )
   ]
        _None,
        [
         Display(
             Name = "dr"
         )
     ]
        Doctor /* a degree, not a title, but whatever */
    ,
        [
         Display(
             Name = "prof."
         )
     ]
        Professor
    };







    public enum
 MedicalFaculty
    {
        _General,
        Allergology,
        Anaesthesiology,
        Andrology,
        Cardiology,
        Cosmetology,
        Dermatology,
        Diabetology,
        Endocrinology,
        Epidemiology,
        Gastroenterology,
        Genetics,
        Gynaecology,
        Hepatology,
        Hypnology,
        Immunology,
        Laryngology,
        Neonatology,
        Neurology,
        Neurosurgery,
        Nephrology,
        Nosology,
        [
            Display(
                Name = "Położnictwo"
            )
        ]
        Obstetrics,
        Oncology,
        Ophthalmology,
        Osteology,
        Paediatry,
        Phlebology,
        Phoniatry,
        Podology,
        Pulmunology,
        Psychiatry,
        Rheumatology,
        Rehabilitation,
        Sexuology,
        Stomatology,
        Surgery,
        Thoracology,
        Transplantology,
        Trichology,
        Toxicology,
        Urology,
        Veterinary,
        Virology
    }






    public
     enum Demesne
    {


        // <URL: https://github.com/dotnet/aspnetcore/issues/7409#issuecomment-1023279636 >
        [
      Display(
          Name = "Pomorskie", Description = "Pomorze Gdańskie"
      )
  ]
        Gdansk = 'G'
        ,



        [
      Display(
          Name = "Zach.-pomorskie", Description = "Pomorze Zachodnie"
      )
  ]
        Stettin = 'S'
        ,



        [
      Display(
          Name = "Podlaskie", Description = "Podlasie i Jaćwież"
      )
  ]
        Bealystok = 'B'
         ,



        [
     Display(
         Name = "Wielkopolskie", Description = "Wielkopolska"
     )
 ]
        Poznan = 'P'
         ,



        [
     Display(
         Name = "Łódzkie", Description = "Ziemia Łęczycka"
     )
 ]
        Lodge = 'l'
         ,



        [
     Display(
         Name = "Mazowiecke", Description = "Mazowsze"
     )
 ]
        Warsaw = 'W'
          ,



        [
     Display(
         Name = "Małopolskie", Description = "Małopolska Zachodnia"
     )
 ]
        Cracow = 'C'
           ,



        [
    Display(
        Name = "Lubuskie", Description = "Ziemia Lubuska"
    )
]
        Greenberg = 'b'
           ,



        [
     Display(
         Name = "Świętokrzyskie", Description = "Ziemia Świętokrzyska"
     )
 ]
        Kelce = 'K'
           ,



        [
     Display(
         Name = "Lubelskie", Description = "Małopolska Wschodnia"
     )
 ]
        Lublin = 'L'
           ,



        [
   Display(
       Name = "Dolnośląskie", Description = "Dolny Śląsk"
   )
]
        Wrotslaw = 'r'
           ,



        [
  Display(
      Name = "Podkarpackie", Description = "Podkarpacie"
  )
]
        Reshow = 'R'
           ,



        [
  Display(
      Name = "Warmińsko-maz.", Description = "Warmia i Mazury"
  )
]
        Allstone = 'A'
         ,



        [
  Display(
      Name = "Śląskie", Description = "Śląsk i Zagłębie"
  )
]
        Catowice = 't'
          ,



        [
  Display(
      Name = "Kujawsko-pom.", Description = "Kujawy i Pomorze"
  )
]
        Thorn = 'T'
           ,




        [
  Display(
      Name = "Opolskie", Description = "Śląsk Opolski"
  )
]
        Opole = 'O'
    }







    public class Workplace
    {








        public int Id
        {
            get; set;
        }
 
        
        
        
        
        
        
        
        
        [Required, MaxLength(0X80
            ),
       Display(
           Name = "Nazwa"
       ), AutoTrim
   ]
        public string
       Name
        {
            get; set;
        } = string.Empty
      ;








        [Required, MaxLength(0X40
            ),
       Display(
           Name = "Miejscowość"
       ), AutoTrim
   ]
        public string
       Town
        {
            get; set;
        } = string.Empty
      ;








        [Required, ZipCode
        ,
    Display(
        Name = "Kod \u2709", Prompt = "12345"
    )
]
        public int
    ZipCode
        {
            get; set;
        } = // Prompt does not work, so let us have a pattern
   0X3039;        public int ZipCode2 => this.ZipCode / 0X3E8; public int
            ZipCode3 => this.ZipCode % 0X3E8
       ;







        [Required,
    Display(
        Name = "Województwo"
    )
]
        public Demesne
     Demesne
        {
            get; set;
        }








        [Required, MaxLength(0X40
            ),
      Display(
          Name = "Ulica"
      ), AutoTrim
  ]
        public string
      Street
        {
            get; set;
        } = string.Empty
     ;




        public const byte
           SHORT_DISPLAY_SIZE = 0X6;


        [Required, MaxLength(0X10
            ),
     Display(
         Name = "Budynek"
     ), AutoTrim
 ]
        public string
     Building
        {
            get; set;
        } = string.Empty
    ;







        [RequiredNA, MaxLength (0X8
            ),
     Display(
         Name = "Biuro"
     ), AutoTrim
 ]
        public string
     Office
        {
            get; set;
        } = RequiredNAAttribute.NAString
            ;









        /// <summary>
        /// Swaps the data of <see langword="this"/> workspace
        /// with <paramref name="that"/> workspace
        /// </summary>
        /// <param name="that">that workspace</param>
        public void
        Swap(
             Workplace that
         )
        {
            foreach (string
                pn in new[] {
                 nameof (
                     this .Name
                 ),
                 nameof (
                     this .ZipCode
                 ),
                 nameof (
                     this .Street
                 ),
                 nameof (
                     this .Building
                 ),
                 nameof (
                     this .Office
                 ),
                 nameof (
                     this .Demesne
                 ),
                }
            )
                Swap(
                typeof(
                    Workplace
                ).GetProperty(
                    pn
                )
       , this, that
                )
                ;
        }
        // TODO: these methods should be public and generic,
        // it is Microsoft’s fault that they are not available.
        static void Swap<Model>
        (
            PropertyInfo?
              pi
              , Model m1, Model m2
        )
        {
            if (
            pi is null
        ) return;
            var gs = pi.GetAccessors();
            Swap(
                m => gs[0X0
                ].Invoke(
                    m, null
                ), (
                    m, v
                ) => gs[
                    0X1
                ].Invoke(
                    m, new object?
                     [] {
                 v

                    }
                ), m1, m2
            );
        }
        static void Swap<Model, Value>(
            Func
             <Model, Value> getter, Action<Model, Value> setter, Model m1, Model m2
        )
        {
            if (
           object
            .Equals
             (m1,
             m2

            )
        ) return;
            var (
               v1, v2
           ) = (
                getter(
                   m1
               ),
                    getter(
                       m2
                   )

           ); if (object
                .Equals(
               v1,
                v2

               )
           ) return;
            setter(
               m1, v2
           ); setter(
               m2, v1
           );

        }
    }




    public class Medic
    {








        public int Id { get; set; }




        [
        Display(
            Name = "Medyk"
        )
    ]
        public Medic Self =>
     this;




        [Required, Display(Name = "Nazwisko"), AutoTrim
             , MaxLength(0X20
            )
       ]
        public string SurName
        { get; set; } = string.Empty;



        [Required
        , Display(Name = "Imię"), AutoTrim
             , MaxLength(0X10
            )
        ]
        public string Name { get;
            set;
        } = string.Empty;



        [Required, Display(Name = "Tytuł"
        )
        ]
        public MedicalTitle
        Title
        { get; set; }


        [Required, Display(Name = "Specjalność"
        ),
            UIHint("MedicalFaculty"
        )
        ]
        public MedicalFaculty
        Faculty
        { get; set; }







        [
        Display(Name = "\u2709Adres poczty elektronicznej"
        , Prompt = "mailto:user@example.com"
        ), DataType(
            DataType.Url
        )
             , MaxStringLength
            (0X40
            )
        ]
        public Uri?
        Email
        { get; set; }







        [
        Display(Name = "\u260ETelefon"
        , Prompt = "tel:+48(22)0123456"
        ),
         // not an Url to avoid broken server-side validation
         // (see <URL: https://github.com/dotnet/dotnet-api-docs/pull/7456 >)
         DataType(
            DataType.Url
        ), MaxStringLength (0X10
            )
        ]
        public Uri?
        Phone
        { get; set; }




        /// <summary>
        /// All workplaces where this medic works
        /// </summary>
        [
             Display(
                 Name = "\u2B13Miejsca pracy"
             ), UIHint(
                 "Count"
             )
         ]
        public ICollection
           <
           MedicWorkplace>?
          Workplaces
        {
            get; set;
        }




        public IEnumerator<Workplace?
                   >?
                   WorkplaceEnumerator
                    => this.Workplaces?.
                    Select(
                        mw => mw.Workplace
                    )
                  .
                  GetEnumerator()
                  ;





        /// <summary>
        /// Whether <see langword="this" /> <see cref="T:Medic"/> works at <paramref name="wp"/>
        /// </summary>
        /// <param name="wp">the workplace in question</param>
        /// <returns></returns>
        public
       bool
        WorksAt(
           Workplace?
            wp
       )
        {
            return this.
        Workplaces?.
        Any(
            mw => wp
             ?.
             Id == mw.Workplace
              ?.
              Id
        ) ?? false;
        }

        static readonly Regex[]
_translationTriggers
 = Array
  .ConvertAll(
   "c([aor]) ([gh])y ri([^a])"
    .Split(), delegate (
      string pat
  ) {
       return new Regex
        (
           pat
       );
   }
);
        /// <summary>
        /// Translates a faculty name from English to Polish.
        /// </summary>
        /// <param name="text">the faculty name in English</param>
        /// <returns>
        /// the corresponding faculty name in Polish
        /// </returns>
        public static
              string TranslateFaculty(
            string text
        )
        {
            if ('_' ==
            text[0X0
            ]
        ) return "Ogólna";
            else
            {
                string[] ser
                  = @"ics yka
surgery chirurgia
y ia
tion cja"
                   .Split()
                  ;
                int ct
                 = ser
                 .Length
                 ; text = $"{ char.ToLower(text[0]) }{ text[0X1..] }";
                for (
                    int x = default; x < ct
                    ; x += 0X2
                )
                {
                    // Ignore empty substrings (caused by MS line endings)
                    string e; while (string .IsNullOrWhiteSpace(e = ser[x]))
                            ++x
                    ;
                    if (
                      text.EndsWith(e)
                      )
                    {
                        text = text[
..^e.Length
                        ] + ser
                         [x + 0X1
                        ]; break;
                    }
                }
                ct = (
                  ser = @"ll l
th t
sio zjo
ae e
ph f
rh r
xi ksy
x ks
v w
oso ozo"
                   .Split()
              )
               .Length;
                for (
                   int x = default; x < ct
                   ; x += 0X2
               )
                { while (string.IsNullOrWhiteSpace(ser[x])) ++x;
                    text = text.Replace(
                   ser
                    [x
                   ], ser
                    [x + 01
                   ]
               );

                }
                ct = Medic .
                    _translationTriggers
                    .Length
               ; ser = @"k$1 $1i ry$1"
                .Split();
                Debug.Assert(
                    ser.Length
                     == ct
                );
                for (
                   int x = default; x < ct
                   ; ++x
               )
                    text = Medic ._translationTriggers
                     [x
                    ].Replace(
                        text, ser
                         [x
                        ]
                    );
                return $"{ char.ToUpper(text[0]) }{ text[0X1..] }"
                ;

            }
        }
        /// <summary>
        /// Updates data for the given workplace or adds a new one.
        /// </summary>
        /// <param name="wp">the workspace to update</param>
        /// <returns>whether a workspace has been updated</returns>
        /// <exception cref="ArgumentNullException"></exception>
        public
       bool
        Update
        (
           Workplace wp
       )
        { (
            typeof(Medic
                ).GetProperty(nameof(this.Workplaces
                ))?.
                GetCustomAttribute<RequiredAttribute
                >() ?? new RequiredAttribute()
                 )
           .Validate(this.Workplaces, nameof(this.Workplaces));
            if (
            this.Workplaces
             is ICollection<MedicWorkplace> wps
        )
                if (
                    wps
                 .Where
                  (
                     mw => wp.Id == mw.Workplace
                      ?.
                      Id
                 ).FirstOrDefault
                  () is MedicWorkplace mw
            )
                {
                    mw.Workplace?.
                    Swap(
                     wp

                )
                    ;
                    return false
                    ;

                }
                else
                {
                    wps.Add(
                        new MedicWorkplace
                         (
                            this, wp
                        )
                    );
                    return true
                    ;
                }
            throw new InvalidOperationException();
        }
    }


    [
        Owned, Table(
            "MedicWorkplace"
        )
    ]
    public class MedicWorkplace
    {
        [
       Required
   ]
        public Medic?
        Medic
        {
            get; set;
        }
        [
       Required
   ]
        public Workplace?
     Workplace
        {
            get; set;
        }
        public MedicWorkplace(
           Medic
            medic, Workplace workplace
       )
        {
            this.Medic = medic; this.Workplace = workplace;
        }
        [
          Obsolete(
              "see <URL: https://github.com/dotnet/efcore/issues/12078 >"
          )
      ]
        private MedicWorkplace(
      )
        {
            if (
            false
        )
                throw new InvalidOperationException(
                "Medic Workplace association created out of thin air"
            );
        }
    }

    public class MedicContext : DbContext
    {
        public MedicContext(
DbContextOptions<MedicContext> opt
        ) : base(
opt
        )
        {

        }
        public DbSet<
Medic
>?
Medics
        {
            get; internal
            set;
        }
        public DbSet<Workplace>?
            Workplaces { get; internal set; }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            _ = modelBuilder.Entity<
            Medic
            >()
            .OwnsMany<MedicWorkplace>(
                (
                    Medic
                    m) => m.Workplaces,
                 (Action<OwnedNavigationBuilder<Medic
                 , MedicWorkplace>>)
                      (
                       mw => mw.WithOwner(
                           mw => mw.Medic
                       )
                   ) + (
                       mw => mw
                 .HasKey("MedicId", "WorkplaceId")
                   ) + (
                       mw => mw.Navigation(
                           mw => mw.Workplace
                       ).AutoInclude()
                   )
);
        }
    }
}
