﻿-- --------------------------------------------------------
-- Host:                         
-- Wersja serwera:               10.6.5-MariaDB - mariadb.org binary distribution
-- Serwer OS:                    Win64
-- HeidiSQL Wersja:              11.3.0.6295
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

-- Zrzut struktury tabela test.medics
CREATE TABLE IF NOT EXISTS `medics` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Email` char(64) DEFAULT NULL,
  `Faculty` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `Name` char(16) NOT NULL,
  `Phone` char(16) DEFAULT NULL,
  `SurName` char(32) NOT NULL,
  `Title` bit(2) NOT NULL DEFAULT b'0',
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='INSERT INTO `Medics` (`Email`, `Faculty`, `Name`, `Phone`, `SurName`, `Title`)';

-- Zrzucanie danych dla tabeli test.medics: ~1 rows (około)
/*!40000 ALTER TABLE `medics` DISABLE KEYS */;
REPLACE INTO `medics` (`Id`, `Email`, `Faculty`, `Name`, `Phone`, `SurName`, `Title`) VALUES
	(1, 'mailto:hermenegilda.wojnarowska@flebologia.przychodnia.com.pl', 27, 'Hermenegilda', 'tel:123456789', 'Grzegorzewska-Wojnarowska', b'01'),
	(4, NULL, 5, 'Reginald', NULL, 'Zapuszczony', b'10');
/*!40000 ALTER TABLE `medics` ENABLE KEYS */;

-- Zrzut struktury tabela test.medicworkplace
CREATE TABLE IF NOT EXISTS `medicworkplace` (
  `MedicId` int(11) NOT NULL,
  `WorkplaceId` int(11) NOT NULL,
  PRIMARY KEY (`MedicId`,`WorkplaceId`),
  KEY `FK_medicworkplace_workplace` (`WorkplaceId`),
  CONSTRAINT `FK_medicworkplace_medics` FOREIGN KEY (`MedicId`) REFERENCES `medics` (`Id`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `FK_medicworkplace_workplace` FOREIGN KEY (`WorkplaceId`) REFERENCES `workplaces` (`Id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;

-- Zrzucanie danych dla tabeli test.medicworkplace: ~2 rows (około)
/*!40000 ALTER TABLE `medicworkplace` DISABLE KEYS */;
REPLACE INTO `medicworkplace` (`MedicId`, `WorkplaceId`) VALUES
	(1, 1),
	(1, 2),
	(4, 2);
/*!40000 ALTER TABLE `medicworkplace` ENABLE KEYS */;

-- Zrzut struktury tabela test.workplaces
CREATE TABLE IF NOT EXISTS `workplaces` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Building` char(16) DEFAULT NULL,
  `Demesne` int(11) NOT NULL,
  `Name` char(128) NOT NULL DEFAULT '',
  `Office` char(8) NOT NULL DEFAULT '',
  `Street` char(64) NOT NULL DEFAULT '',
  `Town` char(64) NOT NULL DEFAULT '',
  `ZipCode` int(11) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='`t`.`Id`, `t`.`Building`, `t`.`Demesne`, `t`.`Name`, `t`.`Office`, `t`.`Street`, `t`.`Town`, `t`.`ZipCode`\r\n';

-- Zrzucanie danych dla tabeli test.workplaces: ~2 rows (około)
/*!40000 ALTER TABLE `workplaces` DISABLE KEYS */;
REPLACE INTO `workplaces` (`Id`, `Building`, `Demesne`, `Name`, `Office`, `Street`, `Town`, `ZipCode`) VALUES
	(1, '55C', 98, 'Wojewódzki Szpital Specjalistyczny im. prof. dr. Witolda Orłowskiego', '443A', 'ul. ppłk. Hermenegildy Grzegorzewskiej-Wojnarowskiej', 'Piestrzychowice Szlacheckie Kolonia', 46587),
	(2, '82', 87, 'Villa Głupawka', '.', 'ul. Gazetowa', 'Kozie Bobki', 12345);
/*!40000 ALTER TABLE `workplaces` ENABLE KEYS */;

/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IFNULL(@OLD_FOREIGN_KEY_CHECKS, 1) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40111 SET SQL_NOTES=IFNULL(@OLD_SQL_NOTES, 1) */;
