﻿using Medic.Data;
using Microsoft.AspNetCore.Html;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.ModelBinding;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Microsoft.Net.Http.Headers;
using System.Text;

/// <summary>
/// Edit model for Medic
/// </summary>
/// 

namespace Medic.
    Pages.Medic
{
    public class EditModel : PageModel
	{
		public
   const char CMD_SAVE = '\u2714', CMD_DELETE = '\u2718';
        /// <summary>
        /// The command arriving on POST
        /// </summary>
        [
	   BindProperty
   ]
		public char Cmd
		{
            get; set;
		}
        /// <summary>
        /// The <see cref="Data.Medic"/> to be edited or <see langword="null"/> to enter a new one
        /// </summary>
        [BindProperty]
        public Data.
			Medic?
            Medic
        { get;
            set;
        }
        public bool IsEdit => this.Medic is Data .
            Medic medic && default != medic.Id;
        public EditModel
            (ILogger<EditModel> logger,
            MedicContext
            context)
        {
            this.
              _context = context; this._logger = logger;
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        /// Read the medic (if applicable)
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public async Task<IActionResult> OnGetAsync(int? id)
        { var logger = this ._logger;
            if (id is int)
            {
                logger
                    .LogTrace("?ID Y"
                    );
                if (
                  this._context.Medics is DbSet<Data.Medic>
                      medics
              )
                {
                    logger
                        .LogTrace("?MEDICS Y"
                        );
                    try
                    {
                        logger
                              .LogTrace("?!FIND"
                          );
                        this.Medic = await
                        medics
                         .
                        FindAsync(
                            id
                        ); return this.Page();

                    }
                    catch (
                       InvalidOperationException ex
                   )
                    {
                        logger.LogTrace("?!FIND X"
                          );
                        const string title = "Brak połączenia z&nbsp;bazą danych!";
                        return new
                    ContentResult
                        {
                            StatusCode = StatusCodes.Status404NotFound,
                            ContentType = new MediaTypeHeaderValue(
                            mediaType: new Microsoft.Extensions.Primitives.StringSegment(
                            "TEXT/HTML"

                            )
                        )
                            {
                                Encoding
                             = Encoding
                             .UTF8
                            }.ToString()
                        ,
                            Content =
                         (
                        $@"<!DOCTYPE HTML ""-//W3C//DTD HTML 4.01//EN"" ><HTML LANG=""pl"" ><TITLE >{
                            title
                        }</TITLE ><STYLE TYPE=""TEXT/CSS"" ><!--
     INPUT {{
         FONT-WEIGHT: BOLDER; FONT-SIZE: 4EM

     }} P.ACK {{
         TEXT-ALIGN: RIGHT
     }}
     --></STYLE 
      ><SCRIPT TYPE=""TEXT/JAVASCRIPT""
      DEFER ><!--
     this
           .onload = function setup
     () {{ this .document .forms .item (
         0
     )
      .onsubmit        = function back () {{
window
 .history .back ()
     }}}}
       // --></SCRIPT ><DIALOG OPEN ><FORM METHOD=DIALOG ACTION="".""
      ><H1 > { title } </H1 >
    <BLOCKQUOTE LANG=""en""
    ><P >
      { new HtmlString(
                             ex.Message

                         )
                              }</BLOCKQUOTE ><P CLASS=""ACK""
            ><INPUT TYPE=SUBMIT TITLE=""Wróćmy do poprzedniej strony!""
            VALUE=""&larr;""
            ></DIALOG ></FORM >
      "

                        )
                        }
                   ;
                    }
                }
                return this.NotFound();
            } else
            {
                logger.LogTrace("?ID N"
                    ); this.Medic = new Data.Medic()
                    {
                        Name = string
                        .Empty
                    }
                    ; return this.Page();
            }
        }

        /// <summary>
        /// Update or delete the medic (depending on the command)
        /// </summary>
        /// <returns></returns>
        public async Task<IActionResult> OnPostAsync(
        )
        {
            ModelStateDictionary ms = this.
               ModelState;
            if (!
             ms
             .IsValid)
            {
                foreach (
                  KeyValuePair<string, ModelStateEntry> kv in ms
              )
                {
                    var v = kv.Value;
                        Console.Error.WriteLine(new
                        {
                            key = kv.Key,
                            value = $"[{ v.RawValue }]"
                            ,
                            valid = v.ValidationState
                        });
                }
                return Page();
            }
            if (this._context is MedicContext context) if (
             this.Medic is Data .
             Medic medic
         ) if (
             CMD_DELETE == this .Cmd
         ) if (
             this._context.Medics is DbSet< Data .
                 Medic> medics
         )
                        {
                            medics.Remove(
                                medic
                            ); await
                            context.SaveChangesAsync
                             ();
                        }
                        else { }
                    else
                    {
                        if (
                            default == medic
                             .
                             Id
                        ) context
                         .Medics?.
                        Add(
                            medic
                        );
                        else context
                                 .Attach(medic
                                 ).State = EntityState.Modified;

                        try
                        {
                            await _context.SaveChangesAsync();
                        }
                        catch (DbUpdateConcurrencyException)
                        {
                            if (!MedicExists(medic
                            .Id))
                            {
                                return NotFound();
                            }
                            else
                            {
                                throw;
                            }
                        }

                    }

            return RedirectToPage("./Index", new
            {
                id = this.Medic?.
                Id
            }
            );
        }

        private bool MedicExists(int id)
        {
            DbSet<Data.Medic>?
           medics =
                _context.Medics;
            return
            medics is DbSet<Data.Medic>
             && medics
             .
             Any(e => e.Id == id);
        }
        private readonly MedicContext _context;
        private readonly ILogger<EditModel> _logger;
    }

}
