﻿using Medic.Data;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using MySqlConnector;
using System.ComponentModel.DataAnnotations;



namespace Medic.Pages.Medic
{


    
	/// <summary>
    /// List medics by name containing <see cref="IndexModel.NameSearch"/>
    /// or by <see cref="IndexModel.Id"/>,
    /// including their respective addresses.
    /// </summary>
    public class IndexModel : 
		PageModel
	{
        /// <summary>
        /// Displays only the medic with the given Id.
        /// </summary>
        /// 

        [ModelBinder
            ]
		public int Id { get; set; }






        [
			AutoTrim, Display(Name =
            "Wyszukiwanie po nazwisku",
		Prompt = "Kawałek nazwiska"
				)
			]


        /// <summary>
        /// Enter a part of a medic’s name to search for!
        /// </summary>
        public
		string?
            NameSearch
		{ get; set; }

        private readonly ILogger<IndexModel> _logger;
        private readonly MedicContext
			_context;




        /// <summary>
        /// The enumerator for the current query for medics
        /// </summary>
        [Display(Name = "Medycy", Description = "Wyliczenie medyków, pasujących do bieżącego zapytania")
            ]
		public

		IEnumerator
 <Data.
    Medic>?
			Enumerator;
        /// <summary>
        /// A failure to remember if we cannot use the database
        /// </summary>
		[Display(
            Name = "Błąd połączenia", Description = "Błąd połączenia z\u2014bazą danych"
            )
            ]
        public MySqlException
            ?
			DatabaseFailure;









		public IndexModel
			(ILogger < IndexModel> logger, MedicContext context
			)
		{
			//
			// TODO: Add constructor logic here
			//
			(
			this._logger = logger
				).LogTrace("Constructing {Model}", this
                ); this._context = context;
		}







        public void
         OnGet
        ()
        { var logger = this ._logger;
            if (
                this.
              _context.Medics is DbSet<Data.Medic>
				medics_all
                )
            {
				logger.LogTrace("?MEDICS Y"
				  );
				var name_search = this.NameSearch;
                var
                    id = this.Id;
				try
                {
                    this.
			  Enumerator
			   =
					medics_all.
					Where(
					string.IsNullOrEmpty(name_search) ?
						m => id == m.Id : m => m.SurName.Contains(
							name_search)
						)
			   .
			   OrderBy(
				   m => m.SurName
			   )
			  .GetEnumerator
			  ();

				} catch (InvalidOperationException ex
				) when (ex .InnerException is MySqlException sqlEx
				)
                {
                    this.DatabaseFailure
                        = sqlEx;
                }


			}
            logger.LogTrace("?MEDICS"
				);

		}

    }

	}
