﻿namespace Medic.Pages;

public static
    class Renderer
{








	/// <summary>
	/// Extract the symbol
	/// </summary>
	/// <param name="caption">the composite caption</param>
	/// <returns>the symbol part of <paramref name="caption" ></paramref></returns>
	public
	static char Symbol(
	  string caption) => caption[0X0
		  ];
	/// <summary>
	/// Extract the tooltip
	/// </summary>
	/// <param name="caption">the composite caption</param>
	/// <returns>the tooltip part of <paramref name="caption" ></paramref></returns>
	public
	static string
		Tooltip(string caption
			  ) => caption[0X1..];









	/// <summary>
	/// Extract 
	/// </summary>
	/// <param name="caption">the composite caption format string</param>
	/// <param name="fillers">objects to fill in the placeholders in the format string</param>
	/// <returns>
	/// the tooltip part of <paramref name="caption" ></paramref>,
	/// and filled with <paramref name="fillers"/>
	/// </returns>
	public static string Tooltip(string caption, params object[] fillers)
		=> string.Format(Tooltip(caption), fillers
			);
}
