﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Medic .
    Data
    ;
using Microsoft.EntityFrameworkCore;
using Microsoft.AspNetCore.Mvc.ModelBinding;

namespace Medic.Pages.Workplace
{






    /// <summary>
    /// A model for editing a <see cref="T:Data.Workplace" />
    /// </summary>
    public class WorkplaceModel : PageModel
    { public
        const char LOOKUP = '\u27B2'
        , SAVE = '\u2714', CUT = '\u29BB'
        ;
        private readonly MedicContext
            _context;

        public ILogger<WorkplaceModel> _logger { get; }

        [Obsolete]
        public WorkplaceModel(MedicContext context, ILogger<WorkplaceModel> logger
                )
        {
            this.
              _context = context; this._logger
               = logger;
        }






        /// <summary>
        /// The <see cref="T:Data.Medic" /> who supposedly works here
        /// </summary>
        /// 
        public Data.
        Medic?
         Medic
        { get; set; }

        /// <summary>
        /// The <see cref="T:Data.Workplace"/> to work with
        /// </summary>
        [Required, BindProperty
             ]
        public Data.Workplace
        ?
         Workplace
        { get; set; }
        /// <summary>
        /// What to do on POST
        /// </summary>
        /// 
        [Required,
            BindProperty
            ]
        public
char
Cmd
        {

            get; set;
        }


        /// <summary>
        /// Whether the <see cref="T:Data.Medic" /> currently works here
        /// </summary>
        public bool IsConnected => this.Medic?.WorksAt(
                      this?.
                      Workplace
                  )
                   ?? false
                  ;
        public async Task<IActionResult> OnGetAsync(
            int
         workplace
         , int medic
        )
        {
            return
                  await
                 this.ProcessRequestAsync(workplace
                 ,
             medic

            )
               ? this.Page
                    () : this.NotFound();
        }
        // To protect from overposting attacks, enable the specific properties you want to bind to.
        // For more details, see https://aka.ms/RazorPagesCRUD.
        public async Task<IActionResult> OnPostAsync(
             int medic, char cmd
        )
        {
            bool filledP;
            using (
               var t =
                 this.ProcessRequestAsync(default
                  ,
                   medic
               )
           ) filledP = await t;
            switch (
           cmd
       )
            {
                case LOOKUP:
                    return this.RedirectToPage(
       "Index", new
       {
           medic,
           pattern
            = this.Workplace?.
           Name
       }
   );
                case CUT
       :
                    this._logger.LogTrace(
                      "*CMD=CUT"
                  ); if (filledP &&
                      this.Medic is Data.
                      Medic medic116 && medic116.Workplaces is ICollection<MedicWorkplace> wps
                  )
                    {
                        this._logger.LogTrace(
                        "?FILLED Y"
                    );
                        medic116.Workplaces.Remove(wps.First
                         (
                            mw => mw.Workplace?.
                            Id ==
                             this.Workplace?.
                             Id
                        )

                        ); var context126 = this._context; context126.Attach(
                           medic116
                       );
                        await context126
                         .SaveChangesAsync();
                    }
                    else
                    {
                        this._logger.LogTrace(
                            "?FILLED N"
                        ); return this.NotFound();
                    }
                    this._logger.LogTrace(
                      "?FILLED"
                  );
                    break;
                case SAVE:
                    this._logger
          .LogTrace(
             "*CMD=SAVE"
         );
                    ModelStateDictionary ms = this.
                     ModelState;
                    if (!
                     ms
                     .IsValid)
                    {
                        this._logger
                       .LogTrace(
                          "?INVALID Y"
                      );
                        foreach (
                        KeyValuePair<string, ModelStateEntry?
                         > kv in ms.Where(
                            kv => ModelValidationState.Invalid ==
                              kv.Value?.ValidationState
                        )
                    ) this._logger
                     .LogError(
                        "Invalid entry {Entry}", kv
                    )
                        ;
                        return
                         filledP
                         ? this.
                          Page() : this.NotFound()
                          ;
                    }
                    this._logger
                   .LogTrace(
                      "?INVALID"
                  );
                    var context = this._context;
                    if (
                                     filledP
                                     &&
                        this.Workplace is Data.
                        Workplace wp
                    )
                    {
                        this._logger
                     .LogTrace(
                        "?ISFILLED Y"
                    );
                        if (
                             this.Medic is Data.
                             Medic medic175
                         )
                        {
                            this._logger
                           .LogTrace(
                              "?ISMEDIC Y"
                          );
                            medic175
                             .Update
                              (
                                wp
                            );
                            context.Attach(medic175
                             ).State = EntityState.Modified;

                        }
                        this._logger
                       .LogTrace(
                          "?ISMEDIC"
                      );
                        if (
                           default ==
                           wp
                            .
                            Id

                       )
                        {
                            this._logger
                         .LogTrace(
                            "?ISNEW Y"
                        );
                            if (
                                string.IsNullOrWhiteSpace(
                                    wp.Name
                                ) &&
                                typeof(Data.
                                    Workplace
                                    ).GetProperty(nameof(wp.Name))
                                    ?.
                                    GetCustomAttributes(false
                                        )[0X0
                                        ] is RequiredAttribute
                                        rq 
                           ) rq .Validate (wp .Name, nameof (wp.Name));
                            context
                           .Workplaces
                           !.
                          Add(wp
                          );

                        }
                        else
                        {
                            this._logger
                      .LogTrace(
                         "?ISNEW N"
                     );

                        }
                        this._logger
                       .LogTrace(
                          "?ISNEW"
                      );

                    }
                    this._logger
                   .LogTrace(
                      "?ISFILLED"
                  );

                    try
                    {
                        this._logger
                       .LogTrace
                        (
                          "!SAVE?"
                      );
                        await context
                        .SaveChangesAsync();
                    }
                    catch (DbUpdateConcurrencyException ex)
                    {
                        this._logger
                       .LogError(
                          ex, "!SAVE!"
                      );
                        if (this.
                        MedicExists
                        (this.
                            Workplace
                        ?.
                        Id))
                        {
                            throw;
                        }
                        else
                        {
                            return this.
                            NotFound();
                        }

                    }
                    this._logger
                   .
                  LogTrace(
                      "!SAVE"
                  ); break;
            }
            this._logger
           .LogTrace(
              "*CMD"
          );
            return this.RedirectToPage(
               "../Medic/Index", new
               {
                   id = this.Medic?.
                   Id
               }
           );
        }
        /// <summary>
        /// Tests whether the medic of <paramref name="id" ></paramref> exists
        /// </summary>
        /// <param name="id">Medic Id</param>
        /// <returns>whether the medic of <paramref name="id" ></paramref> exists</returns>
        private bool MedicExists
            (int?
         id)
        {
            return this.
               _context.Medics
             is DbSet<Data.Medic>
            medics
             && medics
             .
             Any(e => e.Id == id);
        }

    /// <summary>
    /// Fill in
    /// <see cref="P:WorkplaceModel.Workplace"/>
    /// and <see cref="P:WorkplaceModel.Medic"/> from parameters.
    /// </summary>
    /// <param name="workplace">Workplace ID or 0</param>
    /// <param name="medic">Medic ID</param>
    /// <returns></returns>
    private async Task<bool> ProcessRequestAsync(int workplace, int medic)
        {
            var context = this._context; if (
           context.Medics is DbSet<Data.
           Medic
            > medics
           && await medics
             .
           FindAsync
            (
               medic
           ) is Data.
           Medic m

     )
            {
                this.Medic = m; if (
                   this.Workplace
                    is Data.
                    Workplace
               ) return true; if (
                   default ==
                    workplace
               )
                {
                    this.Workplace = new()
                    ; return true;
                }
                if (
                    context.Workplaces is DbSet<Data.
                    Workplace> wps
                )
                {
                    this.Workplace = await
                   wps
                    .FindAsync
                     (
                       workplace
                   )
                   ;
                    return true;

                }
            }
            return false;
        }
    }
}



