using Medic.Data;
using Microsoft.EntityFrameworkCore;
using System.Text.Encodings.Web;
using System.Text.Unicode;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.
builder.Services
    .AddSingleton(
    HtmlEncoder.Create(UnicodeRanges.BasicLatin, UnicodeRanges.Latin1Supplement,
     UnicodeRanges.LatinExtendedA
    )
)
  .AddDbContext<MedicContext
  >(
    delegate (
    DbContextOptionsBuilder
     options
    ) {
        options.UseMySql
        (
           builder.Configuration.GetConnectionString(
              typeof(
                   MedicContext
               ).Name
           ), new MySqlServerVersion(new Version(8, 0, 27))
       );
    }
)
    .AddRazorPages()
    ;

var app = builder.Build();

// Configure the HTTP request pipeline.
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Error");
}
app.UseStaticFiles();

app.UseRouting();

app.UseAuthorization();

app.MapRazorPages();

app.Run();
